#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

void Fail(void);
void Translate(char *pszType);
long FileLength(FILE *pf);

FILE *pfInput;
FILE *pfCFile;
FILE *pfHFile;
char pszWork[300];
char pszBaseFilename[100];
int nSize;
char *pch;

int main(int nArgCount, char *apszArg[])
{
   printf("OpenDoors imbedded ASCII/ANSI/AVATAR/RIP file generator\n\n");

   if(nArgCount != 2)
   {
      printf("  ERROR: One argument is required\n\n");
      Fail();
   }

   if(strchr(apszArg[1], '.'))
   {
      printf("  ERROR: Filename must not contain an extension\n\n");
      Fail();
   }

   strcpy(pszBaseFilename, apszArg[1]);

   strlwr(pszBaseFilename);
   pszBaseFilename[0] = toupper(pszBaseFilename[0]);

   strcpy(pszWork, pszBaseFilename);
   strcat(pszWork, ".c");
   strlwr(pszWork);
   if(!(pfCFile=fopen(pszWork, "w")))
   {
      printf("  ERROR: Unable to open output file %s\n\n", pszWork);
      Fail();
   }

   fprintf(pfCFile, "/* %s : .C Module for an imbedded OpenDoors .ASC/.ANS/.AVT/.RIP file */\n\n", pszWork);

   strcpy(pszWork, pszBaseFilename);
   strcat(pszWork, ".h");
   strlwr(pszWork);
   if(!(pfHFile=fopen(pszWork, "w")))
   {
      printf("  ERROR: Unable to open output file %s\n\n", pszWork);
      Fail();
   }

   fprintf(pfHFile, "/* %s : External definitions for an imbedded OpenDoors .ASC/.ANS/.AVT/.RIP file */\n\n", pszWork);
   fprintf(pfHFile, "void DisplayImbedded(char *pszAscii, char *pszAnsi, char *pszAvatar, char *pszRip);\n\n");

   Translate("ASC");
   Translate("ANS");
   Translate("AVT");
   Translate("RIP");

   fclose(pfCFile);
   fclose(pfHFile);

   return(0);
}


void Translate(char *pszType)
{
   strcpy(pszWork, pszBaseFilename);
   strcat(pszWork, ".");
   strcat(pszWork, pszType);
   strlwr(pszWork);
   if(!(pfInput=fopen(pszWork, "rb"))) return;

   printf("  Imbedding %s\n", pszWork);

   nSize = (int) FileLength(pfInput);

   strcpy(pszWork, pszBaseFilename);
   pch = strrchr(pszWork, ' \\');
   if(pch)
   {
      ++pch;
   }
   else
   {
      pch = pszWork;
   }

   fprintf(pfCFile, "char sz%s%s[%d] = {\n", pch, pszType, nSize + 1);
   fprintf(pfHFile, "extern char sz%s%s[%d];\n", pch, pszType, nSize + 1);

   while(!feof(pfInput))
   {
      if((nSize = fread(pszWork, 1, 16, pfInput)) == 0) break;
      pszWork[nSize]='\0';
      for(pch = pszWork; *pch; ++pch)
      {
	 fprintf(pfCFile, "%-3d, ", (int)(unsigned char)*pch);
      }
      fprintf(pfCFile, "\n");
   }

   fprintf(pfCFile,"0 };\n\n");

   fclose(pfInput);
}


long FileLength(FILE *pf)
{
   long int lOriginal;
   long int lToReturn;

   lOriginal = ftell(pf);
   fseek(pf, 0L, SEEK_END);
   lToReturn = ftell(pf);
   fseek(pf, lOriginal, SEEK_SET);
   return(lToReturn);
}


void Fail(void)
{
   printf("  Format: imbed [basename]\n\n");
   printf("  Basename is the name, without extention, of the .ASC/.ANS/.AVT file set\n");
   printf("   to be added to the output files, basename.h, basename.c\n");

   exit(1);
}
